/* kbd_leds.c -- enables the keyboard-led-handling
 *
 * Thanks to Benjamin Osheroff (osheroff@netcom.com) for mailleds
 * and to Andreas Steffan (deas@rrz.uni-hamburg.de) for asking for 
 * that feature
 * 
 * this code is part of the xled program
 *
 * Copyright 1997 Jan Schoenepauck & Joachim Gassen 
 * aka Fast Forward Productions
 *
 * check out http://fb4-1112.uni-muenster.de/ffwd
 *
 */

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>

#include "kbd_leds.h"
#include "global.h"

int kbd_leds[3];
int kbd_led_mask;
int kbd_leds_cleared=1;
int use_kbd_leds=0;

void init_kbd_leds (void) {
  int i = 0;
  if ( kbd_led_mask & X_CAP )
    kbd_leds[i++] = 1;
  if ( kbd_led_mask & X_NUM )
    kbd_leds[i++] = 2;
  if ( kbd_led_mask & X_SCR )
    kbd_leds[i++] = 3;
  kbd_leds[i] = 0;
}

void set_kbd_leds(int mode) {
  int x;
  XKeyboardControl kbd;
  kbd.led_mode = mode;
  for(x=0; kbd_leds[x]; x++)
    {
      kbd.led = kbd_leds[x];
      XChangeKeyboardControl(display, KBLed | KBLedMode, &kbd);
    }
}

void toggle_kbd_leds (void) {
  XKeyboardState kbd_state;
  XGetKeyboardControl(display, &kbd_state);
  if (kbd_state.led_mask&kbd_led_mask) set_kbd_leds(LedModeOff);
  else set_kbd_leds(LedModeOn);
  kbd_leds_cleared = 0;
}

void clear_kbd_leds (void) {
  set_kbd_leds(LedModeOff);
  kbd_leds_cleared = 1;
}





